> This page is for Developer.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.bigcommerce.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://docs.bigcommerce.com/_mcp/server.

# Create Cart Metafield

POST https://api.bigcommerce.com/stores/{store_hash}/v3/carts/{cart_id}/metafields
Content-Type: application/json

Create a cart `Metafield`. 

If you create an order from a Cart, you can continue referencing the Cart Metafields even if you delete the original Cart. Use the `cart_id` field on the Order to construct the Cart Metafield endpoint.


Reference: https://docs.bigcommerce.com/developer/api-reference/rest/admin/management/carts/metafields/create-cart-metafield

## Authentication

- `X-Auth-Token` header (required) — ### OAuth scopes | UI Name | Permission | Parameter | |:--------|:-----------|:----------| |Carts|modify|`store_cart`| |Carts |read-only|`store_cart_read_only`| |Information & Settings | modify | `store_v2_information`| |Information & Settings | read-only| `store_v2_information`| ### Authentication header | Header | Argument | Description | |:-------|:---------|:------------| | `X-Auth-Token` | `access_token` | For more about API accounts that generate `access_token`s, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#api-accounts). | ### Further reading For example requests and more information about authenticating BigCommerce APIs, see [Authentication and Example Requests](/developer/docs/overview/api-fundamentals/api-accounts#x-auth-token-header-example-requests). For more about BigCommerce OAuth scopes, see our [Guide to API Accounts](/developer/docs/overview/api-fundamentals/api-accounts#oauth-scopes). For a list of API status codes, see [API Status Codes](/developer/api-reference/rest/overview#rest-http-status-codes).

## Request

### Path parameters

- `cart_id` (string, required) — The ID of the `Cart` to which the transactions belong.
- `store_hash` (string, required) — Permanent ID of the BigCommerce store.

### Headers

- `Accept` (string, required, default: application/json) — The [MIME type](https://developer.mozilla.org/en-US/docs/Web/HTTP/Basics_of_HTTP/MIME_types) of the response body.

### Body (application/json)

This endpoint expects a MetafieldBase_Post.

- `permission_set` (enum, required) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `namespace` (string, required) — Namespace for the metafield, for organizational purposes.
- `key` (string, required) — The name of the field, for example: `location_id`, `color`.
- `value` (string, required) — The value of the field, for example: `1`, `blue`.
- `description` (string, optional) — Description for the metafields.

## Response

### 200

A `Metafield` object.

- `data` (Metafield, optional) — Allows app partners to write custom data to various resources in the API.
- `meta` (metaCollection_open, optional) — Response metadata.

## Errors

### 400 Bad Request Error

Bad Request. Input is invalid.

- `status` (double, optional)
- `title` (string, optional)
- `type` (string, optional)
- `detail` (string, optional)

### 409 Conflict Error

The `Metafield` conflicts with another `Metafield`. This can result from duplicate unique key combinations of the appʼs client id, namespace, key, resource_type, and resource_id.

- `status` (integer, optional)
- `title` (string, optional)
- `type` (string, optional)
- `instance` (string, optional)
- `errors` (ErrorResponseErrors, optional)

### 422 Unprocessable Entity Error

The `Metafield` was not valid. This is the result of missing required fields, or of invalid data. See the response for more details.

- `status` (integer, optional)
- `title` (string, optional)
- `type` (string, optional)
- `instance` (string, optional)
- `errors` (ErrorResponseErrors, optional)

## Types

### Metafield

Allows app partners to write custom data to various resources in the API.

- `date_created` (datetime, optional) — Date and time of the metafieldʼs creation.
- `date_modified` (datetime, optional) — Date and time when the metafield was last updated.
- `description` (string, optional) — Description for the metafields.
- `id` (string, optional) — The unique identifier for the metafield.
- `key` (string, optional) — The name of the field, for example: `location_id`, `color`.
- `namespace` (string, optional) — Namespace for the metafield, for organizational purposes.
- `owner_client_id` (string, optional) — Client ID for the metafieldʼs creator.
- `permission_set` (enum, optional) — Determines the visibility and writeability of the field by other API consumers. | Value | Description | | :--- | :--- | | `app_only` | Private to the app that owns the field. | | `read` | Visible to other API consumers. | | `write` | Open for reading and writing by other API consumers. | | `read_and_sf_access` | Visible to other API consumers, including on the storefront. | | `write_and_sf_access` | Open for reading and writing by other API consumers, including on the storefront. |
  - Allowed values: `app_only`, `read`, `write`, `read_and_sf_access`, `write_and_sf_access`
- `resource_id` (string, optional) — The unique identifier for the resource with which the metafield is associated.
- `resource_type` (enum, optional) — The type of resource with which the metafield is associated.
  - Allowed values: `brand`, `product`, `variant`, `category`, `cart`
- `value` (string, optional) — The value of the field, for example: `1`, `blue`.

### metaCollection_open

Response metadata.

### ErrorResponseErrors

## Examples

**Request**

```json
{
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Sam",
  "description": "Name of staff member"
}
```

**Response**

```json
{
  "data": {
    "date_created": "2023-11-15T15:16:35+00:00",
    "date_modified": "2023-11-15T15:16:35+00:00",
    "description": "Name of staff member",
    "id": "24",
    "key": "Staff Name",
    "namespace": "Sales Department",
    "permission_set": "app_only",
    "resource_id": "b810114d-9926-45b7-bba5-7633b251154b",
    "resource_type": "cart",
    "value": "Sam"
  },
  "meta": {}
}
```

**SDK Code**

```python Create a cart metafield
import requests

url = "https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields"

payload = {
    "permission_set": "app_only",
    "namespace": "Sales Department",
    "key": "Staff Name",
    "value": "Sam",
    "description": "Name of staff member"
}
headers = {
    "Accept": "application/json",
    "X-Auth-Token": "<apiKey>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript Create a cart metafield
const url = 'https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields';
const options = {
  method: 'POST',
  headers: {
    Accept: 'application/json',
    'X-Auth-Token': '<apiKey>',
    'Content-Type': 'application/json'
  },
  body: '{"permission_set":"app_only","namespace":"Sales Department","key":"Staff Name","value":"Sam","description":"Name of staff member"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go Create a cart metafield
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields"

	payload := strings.NewReader("{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Sam\",\n  \"description\": \"Name of staff member\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Accept", "application/json")
	req.Header.Add("X-Auth-Token", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Create a cart metafield
require 'uri'
require 'net/http'

url = URI("https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Accept"] = 'application/json'
request["X-Auth-Token"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Sam\",\n  \"description\": \"Name of staff member\"\n}"

response = http.request(request)
puts response.read_body
```

```java Create a cart metafield
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields")
  .header("Accept", "application/json")
  .header("X-Auth-Token", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Sam\",\n  \"description\": \"Name of staff member\"\n}")
  .asString();
```

```php Create a cart metafield
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields', [
  'body' => '{
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Sam",
  "description": "Name of staff member"
}',
  'headers' => [
    'Accept' => 'application/json',
    'Content-Type' => 'application/json',
    'X-Auth-Token' => '<apiKey>',
  ],
]);

echo $response->getBody();
```

```csharp Create a cart metafield
using RestSharp;

var client = new RestClient("https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields");
var request = new RestRequest(Method.POST);
request.AddHeader("Accept", "application/json");
request.AddHeader("X-Auth-Token", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"permission_set\": \"app_only\",\n  \"namespace\": \"Sales Department\",\n  \"key\": \"Staff Name\",\n  \"value\": \"Sam\",\n  \"description\": \"Name of staff member\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Create a cart metafield
import Foundation

let headers = [
  "Accept": "application/json",
  "X-Auth-Token": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = [
  "permission_set": "app_only",
  "namespace": "Sales Department",
  "key": "Staff Name",
  "value": "Sam",
  "description": "Name of staff member"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.bigcommerce.com/stores/store_hash/v3/carts/cart_id/metafields")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```